/* メモリ定義 */
INCLUDE ../memory.ld

start = ORIGIN(FLASH);

SECTIONS
{
	.isr_vector :
	{
		. = ALIGN(4);
		KEEP(*(.isr_vector))
		. = ALIGN(4);
	} > FLASH

	.init_array :
	{
		. = ALIGN(4);
		__init_array_start = .;
		KEEP(*(SORT(.init_array.*)))
		KEEP(*(.init_array))
		. = ALIGN(4);
		__init_array_end = .;
	} > FLASH

	.ARM.extab :
	{
		*(.ARM.extab* .gnu.linkonce.armextab.*)
	} >FLASH
	.ARM.exidx :
	{
		*(.ARM.exidx* .gnu.linkonce.armexidx.*)
	} >FLASH
	
	.text :
	{
		. = ALIGN(4);
		*(.text)
		*(.text.*)
		*(.rodata)
		*(.rodata*)
		. = ALIGN(4);
	} >FLASH

	_sidata = .;

	.data  : AT ( _sidata )
	{
		. = ALIGN(4);
		_sdata = . ;
		*(.data)
		*(.data.*)
		. = ALIGN(4);
		_edata = . ;
	} >RAM

	.bss :
	{
		. = ALIGN(4);
		_sbss = .;
		*(.bss)
		*(.bss.*)
		*(COMMON)
		. = ALIGN(4);
		_ebss = . ;
	} >RAM

	DISCARD 0 :
	{
		libc.a(*)
		libm.a(*)
		libgcc.a(*)
		*(.comment)
		*(.ARM.attributes)
		*(.debug_frame)
	}
}
