/* メモリ定義 */
INCLUDE ../memory.ld
/* 強制的に取り込むシンボル名リスト */
INCLUDE includes.txt

/*
__Stack_Size = 1024 ;
PROVIDE ( _Stack_Size = __Stack_Size ) ;

__Stack_Init = _estack  - __Stack_Size ;
PROVIDE ( _Stack_Init = __Stack_Init ) ;
*/

SECTIONS
{
	.init_array :
	{
		. = ALIGN(4);
		__init_array_start_st = .;
		KEEP(*(SORT(.init_array.*)))
		KEEP(*(.init_array))
		. = ALIGN(4);
		__init_array_end_st = .;
	} > FLASHst

	.ARM.extab :
	{
		*(.ARM.extab* .gnu.linkonce.armextab.*)
	} >FLASHst
	.ARM.exidx :
	{
		*(.ARM.exidx* .gnu.linkonce.armexidx.*)
	} >FLASHst
	
	.text :
	{
		. = ALIGN(4);
		*(.text)
		*(.text.*)
		*(.rodata)
		*(.rodata*)
		. = ALIGN(4);
	} >FLASHst

	_sidata_st = .;

	.data  : AT ( _sidata_st )
	{
		. = ALIGN(4);
		_sdata_st = . ;
		*(.data)
		*(.data.*)
		. = ALIGN(4);
		_edata_st = . ;
	} >RAMst

	.bss :
	{
		. = ALIGN(4);
		_sbss_st = .;
		*(.bss)
		*(.bss.*)
		*(COMMON)
		. = ALIGN(4);
		_ebss_st = . ;
	} >RAMst
	
	_end = _ebss_st;

	._usrstack :
	{
		. = ALIGN(4);
		_susrstack = . ;
		. = . + _Minimum_Stack_Size ;
		. = ALIGN(4);
		_eusrstack = . ;
	} >RAMst
	
	DISCARD 0 :
	{
		libc.a ( * )
		libm.a ( * )
		libgcc.a ( * )
		*(.comment)
		*(.ARM.attributes)
		*(.debug_frame)
	}
}
